VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "vbzTipp: Special Folders"
   ClientHeight    =   2730
   ClientLeft      =   4125
   ClientTop       =   3945
   ClientWidth     =   6870
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2730
   ScaleWidth      =   6870
   Begin VB.OptionButton Option1 
      Caption         =   "Eigene &Dateien"
      Height          =   315
      Index           =   0
      Left            =   3840
      TabIndex        =   10
      Tag             =   "5"
      Top             =   240
      Width           =   1455
   End
   Begin VB.OptionButton Option1 
      Caption         =   "Eigene &Musik"
      Height          =   315
      Index           =   1
      Left            =   3840
      TabIndex        =   9
      Tag             =   "13"
      Top             =   660
      Width           =   1455
   End
   Begin VB.OptionButton Option1 
      Caption         =   "Eigene &Videos"
      Height          =   315
      Index           =   2
      Left            =   3840
      TabIndex        =   8
      Tag             =   "14"
      Top             =   1080
      Width           =   1455
   End
   Begin VB.OptionButton Option1 
      Caption         =   "&Windows"
      Height          =   315
      Index           =   3
      Left            =   5460
      TabIndex        =   7
      Tag             =   "36"
      Top             =   240
      Width           =   1275
   End
   Begin VB.OptionButton Option1 
      Caption         =   "&Fonts"
      Height          =   315
      Index           =   4
      Left            =   5460
      TabIndex        =   6
      Tag             =   "20"
      Top             =   660
      Width           =   1275
   End
   Begin VB.OptionButton Option1 
      Caption         =   "&System"
      Height          =   315
      Index           =   5
      Left            =   5460
      TabIndex        =   5
      Tag             =   "37"
      Top             =   1080
      Width           =   1275
   End
   Begin VB.TextBox Text1 
      Height          =   255
      Left            =   120
      Locked          =   -1  'True
      TabIndex        =   3
      Top             =   1680
      Width           =   6615
   End
   Begin VB.CommandButton cmdDebug 
      Caption         =   "Debug Listing ..."
      Height          =   375
      Left            =   3840
      TabIndex        =   2
      Top             =   2160
      Width           =   1335
   End
   Begin VB.CommandButton cmdEnd 
      Caption         =   "&Beenden"
      Height          =   375
      Left            =   5400
      TabIndex        =   0
      Top             =   2160
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   $"frmMain.frx":0CCA
      ForeColor       =   &H00FF0000&
      Height          =   1215
      Left            =   180
      TabIndex        =   4
      Top             =   240
      Width           =   3495
   End
   Begin VB.Label vbzentrum 
      Caption         =   "www.vb-zentrum.de"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   225
      Left            =   120
      TabIndex        =   1
      ToolTipText     =   "zur Homepage..."
      Top             =   2340
      Width           =   1770
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' vbzTipp   : Dateisystem / SpecialFolder
' Nummer    : 0003
' Stand     : 02.12.2004
' Quelle    : http://www.vb-zentrum.de

Option Explicit

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias _
        "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
        
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" _
        (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
                
Private Type ITEMID
  cb As Long
  abID As Byte
End Type

Private Type ITEMIDLIST
  mkid As ITEMID
End Type

Enum SF_VALUE
  SF_DESKTOP = &H0
  SF_PROGRAMME = &H2
  SF_EIGENE_DATEIEN = &H5
  SF_FAVORITEN = &H6
  SF_AUTOSTART = &H7
  SF_DOKUMENTE = &H8
  SF_SENDEN_AN = &H9
  SF_STARTMEN = &HB
  SF_EIGENE_MUSIK = &HD
  SF_EIGENE_VIDEOS = &HE
  SF_NETZWERKUMGEBUNG = &H13
  SF_FONTS = &H14
  SF_VORLAGEN = &H15
  SF_WINDOWS = &H24
  SF_SYSTEM = &H25
End Enum

Function getSpecialFolder(Num As SF_VALUE) As String
  Dim Buff As String * 512
  Dim idl As ITEMIDLIST
    
  If SHGetSpecialFolderLocation(0, Num, idl) = 0 Then
    If SHGetPathFromIDList(ByVal idl.mkid.cb, ByVal Buff) Then
      'bis NullByte auslesen
      getSpecialFolder = Left$(Buff, InStr(1, Buff, vbNullChar) - 1)
   End If
  End If
  
End Function

Private Sub cmdDebug_Click()
  Dim i As Long
  Dim path As String
  
  For i = 0 To 200
    path = getSpecialFolder(i)
    If path <> "" Then
      Debug.Print "Nummer &H" & Hex(i) & ": " & path
    End If
  Next i
End Sub

Private Sub cmdEnd_Click()
  Unload Me
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Set frmMain = Nothing
End Sub

Private Sub Option1_Click(Index As Integer)
  Select Case Index
    Case 0
      Text1 = getSpecialFolder(SF_EIGENE_DATEIEN)
    Case 1
      Text1 = getSpecialFolder(SF_EIGENE_MUSIK)
    Case 2
      Text1 = getSpecialFolder(SF_EIGENE_VIDEOS)
      ' Existiert das Verzeichnis (bei lteren Betriebssystemen) nicht,
      ' so kann es auf diese Weise erstellt werden, statt der Zuweisung
      ' auf die Text1-Eigenschaft:
      If Text1 = "" Then getSpecialFolder (SF_EIGENE_DATEIEN) & "\Eigene Videos"
    Case 3
      Text1 = getSpecialFolder(SF_WINDOWS)
    Case 4
      Text1 = getSpecialFolder(SF_FONTS)
    Case 5
      Text1 = getSpecialFolder(SF_SYSTEM)
  End Select
End Sub

Private Sub vbzentrum_Click()
  Me.MousePointer = vbHourglass
  ShellExecute Me.hWnd, "Open", "http://www.vb-zentrum.de", "", "", vbNormalFocus
  Me.MousePointer = vbDefault
End Sub
